/* Monitor configuration file. */
#define CPU_BE

#define DEFAULT_ETHERADD    "00:23:31:60:00:00"
#define DEFAULT_IPADD       "192.168.254.214"

#define PLATFORM_NAME       "Cogent CSB360"

#define CPU_NAME    "MCF5272"

#define DONT_CENTER_MONHEADER

#define MONSTACKSIZE	0x2000

#define RAM_VECTOR_TABLE	0x0

/* LOOPS_PER_SECOND:
   Approximately the size of a loop that will cause a 1-second delay.
*/
#define LOOPS_PER_SECOND	35000

/* Flash bank configuration:
 * The CSB360 can be populated with either a 28F128 (16Mg) or a
 * 28F640 (8Mg).  In either case, the base address is 0xff000000
 * with the upper 16Mg available (the '640 will only use half).
#define FLASHRAM_BASE			0x380000
 */
#ifdef FLASHRAM_BASE
# define FLASHRAM_END			0x3fffff
# define FLASHRAM_SECTORSIZE	0x010000
# define FLASHRAM_SPARESIZE		FLASHRAM_SECTORSIZE
# define FLASHRAM_SECTORCOUNT	8
# define FLASHRAM_BANKNUM		1
# define FLASHBANKS				2
#else
# define FLASHBANKS				1
#endif
#define SINGLE_FLASH_DEVICE 	1
#define FLASH_COPY_TO_RAM 		1
#define FLASH_BANK0_BASE_ADDR  	0xFF000000
#define FLASH_PROTECT_RANGE  	"0-2"
#define FLASH_BANK0_WIDTH       2
#define FLASH_LARGEST_SECTOR    0x20000
#define LOCK_FLASH_PROTECT_RANGE

/* TFS definitions:
 */
#define TFSSPARESIZE    		FLASH_LARGEST_SECTOR
#define TFSSTART        		(FLASH_BANK0_BASE_ADDR+0x80000)
#define TFSEND          		0xFF7DFFFF
#define TFSSPARE        		(TFSEND+1)
#define TFSSECTORCOUNT			((TFSSPARE-TFSSTART)/0x20000)
#define TFS_EBIN_ELF    		1
#define TFS_VERBOSE_STARTUP		1
#define TFS_AUTOBOOT_ABORTABLE	    

/* Specify the size of the memory block (in monitor space) that
 * is to be allocated to malloc in the monitor.  Note that this
 * size can be dynamically increased using the heap command at
 * runtime.
 */
#define ALLOCSIZE 64*1024

/* INCLUDE_XXX Macros:
 * The sanity of this list is tested through the inclusion of
 * "inc_check.h" at the bottom of this list...
 */
								
#define INCLUDE_MEMCMDS         1
#define INCLUDE_EDIT            1
#define INCLUDE_DISASSEMBLER    1
#define INCLUDE_UNZIP           1
#define INCLUDE_ETHERNET        1
#define INCLUDE_ICMP			1
#define INCLUDE_TFTP            1
#define INCLUDE_TFS             1
#define INCLUDE_FLASH           1
#define INCLUDE_XMODEM          1
#define INCLUDE_LINEEDIT        1
#define INCLUDE_DHCPBOOT        1
#define INCLUDE_TFSAPI          1
#define INCLUDE_TFSSYMTBL       1
#define INCLUDE_TFSSCRIPT       1
#define INCLUDE_TFSCLI          1
#define INCLUDE_EE              1
#define INCLUDE_GDB             1
#define INCLUDE_STRACE          1
#define INCLUDE_CAST            1
#define INCLUDE_STRUCT          1
#define INCLUDE_SHELLVARS		1
#define INCLUDE_MALLOC			1
#define INCLUDE_REDIRECT        1
#define INCLUDE_QUICKMEMCPY     1
#define INCLUDE_PROFILER        1
#define INCLUDE_BBC             0
#define INCLUDE_MEMTRACE        1
#define INCLUDE_STOREMAC        1
#define INCLUDE_TRAPCMD			1
#define INCLUDE_PORTCMD			0
#define INCLUDE_VERBOSEHELP		1
#define INCLUDE_HWTMR			0
#define INCLUDE_SYSLOG			1
#define INCLUDE_USRLVL			1

#include "inc_check.h"
